unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    Timer: TTimer;
    Selector: TRadioGroup;
    SpeedBar: TScrollBar;
    Frame: TScrollBox;
    AnimWindow: TImage;
    Label1: TLabel;
    StopBtn: TBitBtn;
    StartBtn: TBitBtn;
    BitBtn1: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure StartBtnClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  B, Spr: TBitmap;
  Buf: TBitmap;
  Angle, Pos: Integer;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  B:=TBitmap.Create;
  Buf:=TBitmap.Create;
  Spr:=TBitmap.Create;
  B.LoadFromFile('theme.bmp');
  Spr.LoadFromFile('256color.bmp');
  Buf.Width:=200;
  Buf.Height:=200;
end;

procedure TForm1.TimerTimer(Sender: TObject);
  procedure Cub3D(X1, Y1, A: Integer);
    var X, Y, i, j: Integer;
  begin
    with Buf.Canvas do begin
      for j:=0 to 1 do
      for i:=1 to 5 do begin
        X:=Trunc(Sin((A+i*90)*Pi/180)*100+100+X1);
        Y:=Trunc(Cos((A+i*90)*Pi/180)*50+50+Y1+j*100);
        if i=1 then MoveTo(X, Y) else LineTo(X, Y);
      end;
      for i:=1 to 4 do begin
        X:=Trunc(Sin((A+i*90)*Pi/180)*100+100+X1);
        Y:=Trunc(Cos((A+i*90)*Pi/180)*50+50+Y1);
        MoveTo(X, Y);
        LineTo(X, Y+100);
      end;
    end;
  end;
  procedure Piramid3D(X1, Y1, A: Integer);
    var X, Y, i: Integer;
  begin
    with Buf.Canvas do begin
      for i:=1 to 7 do begin
        X:=Trunc(Sin((A+i*60)*Pi/180)*100+100+X1);
        Y:=Trunc(Cos((A+i*60)*Pi/180)*50+50+Y1+100);
        if i=1 then MoveTo(X, Y) else LineTo(X, Y);
      end;
      for i:=1 to 6 do begin
        X:=Trunc(Sin((A+i*60)*Pi/180)*100+100+X1);
        Y:=Trunc(Cos((A+i*60)*Pi/180)*50+50+Y1);
        MoveTo(X1+100, Y1);
        LineTo(X, Y+100);
      end;
    end;
  end;
  procedure Crystal3D(X1, Y1, A: Integer);
    var X, Y, i, j: Integer;
  begin
    with Buf.Canvas do begin
      for i:=1 to 7 do begin
        X:=Trunc(Sin((A+i*60)*Pi/180)*100+100+X1);
        Y:=Trunc(Cos((A+i*60)*Pi/180)*50+Y1+100);
        if i=1 then MoveTo(X, Y) else LineTo(X, Y);
      end;
      for j:=0 to 1 do
      for i:=1 to 6 do begin
        X:=Trunc(Sin((A+i*60)*Pi/180)*100+100+X1);
        Y:=Trunc(Cos((A+i*60)*Pi/180)*50+Y1);
        MoveTo(X1+100, Y1+j*200);
        LineTo(X, Y+100);
      end;
    end;
  end;
  procedure Sprite(Speed: Integer);
    var i, j: Integer;
  begin
    for i:=0 to 5 do
      for j:=0 to 5 do
        Buf.Canvas.Draw(i*80, (j-1)*50+Pos, Spr);
    Pos:=Pos+Speed;
    if Pos>50 then Pos:=0;
  end;
begin
  if Selector.ItemIndex<>3 then
    Buf.Canvas.Draw(0, 0, B);
  case Selector.ItemIndex of
    0: Cub3D(0, 0, Angle);
    1: Piramid3D(0, 0, Angle);
    2: Crystal3D(0, 0, Angle);
    3: Sprite(SpeedBar.Position);
  end;
  AnimWindow.Canvas.Draw(0, 0, Buf);
  Angle:=Angle+SpeedBar.Position;
  if Angle>360 then Angle:=0;
end;

procedure TForm1.StopBtnClick(Sender: TObject);
begin
  StopBtn.Enabled:=False;
  StartBtn.Enabled:=True;
  Timer.Enabled:=False;
end;

procedure TForm1.StartBtnClick(Sender: TObject);
begin
  StopBtn.Enabled:=True;
  StartBtn.Enabled:=False;
  Timer.Enabled:=True;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Close;
end;

end.
